Index: src/work/jacint/max_flow.h
===================================================================
--- src/work/jacint/max_flow.h	(revision 510)
+++ src/work/jacint/max_flow.h	(revision 555)
@@ -46,6 +46,6 @@
 #include <graph_wrapper.h>
 #include <bfs_iterator.h>
-#include <invalid.h>
-#include <maps.h>
+#include <hugo/invalid.h>
+#include <hugo/maps.h>
 #include <for_each_macros.h>
 
Index: src/work/klao/iter_map.h
===================================================================
--- src/work/klao/iter_map.h	(revision 367)
+++ src/work/klao/iter_map.h	(revision 555)
@@ -11,5 +11,5 @@
 #include <cstring>
 
-#include <invalid.h>
+#include <hugo/invalid.h>
 
 namespace hugo {
Index: src/work/marci/bfsit_vs_byhand.cc
===================================================================
--- src/work/marci/bfsit_vs_byhand.cc	(revision 389)
+++ src/work/marci/bfsit_vs_byhand.cc	(revision 555)
@@ -5,6 +5,6 @@
 #include <list_graph.h>
 //#include <smart_graph.h>
-#include <dimacs.h>
-#include <time_measure.h>
+#include <hugo/dimacs.h>
+#include <hugo/time_measure.h>
 #include <for_each_macros.h>
 #include <bfs_iterator.h>
Index: src/work/marci/bipartite_graph_wrapper.h
===================================================================
--- src/work/marci/bipartite_graph_wrapper.h	(revision 510)
+++ src/work/marci/bipartite_graph_wrapper.h	(revision 555)
@@ -11,5 +11,5 @@
 ///\author Marton Makai
 
-#include <invalid.h>
+#include <hugo/invalid.h>
 #include <iter_map.h>
 #include <graph_wrapper.h>
Index: src/work/marci/bipartite_graph_wrapper_test.cc
===================================================================
--- src/work/marci/bipartite_graph_wrapper_test.cc	(revision 496)
+++ src/work/marci/bipartite_graph_wrapper_test.cc	(revision 555)
@@ -7,10 +7,10 @@
 //#include <smart_graph.h>
 //#include <dimacs.h>
-#include <time_measure.h>
+#include <hugo/time_measure.h>
 #include <for_each_macros.h>
 #include <bfs_iterator.h>
 #include <graph_wrapper.h>
 #include <bipartite_graph_wrapper.h>
-#include <maps.h>
+#include <hugo/maps.h>
 #include <max_flow.h>
 
Index: src/work/marci/bipartite_matching_try.cc
===================================================================
--- src/work/marci/bipartite_matching_try.cc	(revision 498)
+++ src/work/marci/bipartite_matching_try.cc	(revision 555)
@@ -8,10 +8,10 @@
 //#include <smart_graph.h>
 //#include <dimacs.h>
-#include <time_measure.h>
+#include <hugo/time_measure.h>
 #include <for_each_macros.h>
 #include <bfs_iterator.h>
 #include <graph_wrapper.h>
 #include <bipartite_graph_wrapper.h>
-#include <maps.h>
+#include <hugo/maps.h>
 #include <max_flow.h>
 
Index: src/work/marci/bipartite_matching_try_2.cc
===================================================================
--- src/work/marci/bipartite_matching_try_2.cc	(revision 510)
+++ src/work/marci/bipartite_matching_try_2.cc	(revision 555)
@@ -8,9 +8,9 @@
 //#include <smart_graph.h>
 //#include <dimacs.h>
-#include <time_measure.h>
+#include <hugo/time_measure.h>
 #include <for_each_macros.h>
 #include <bfs_iterator.h>
 #include <bipartite_graph_wrapper.h>
-#include <maps.h>
+#include <hugo/maps.h>
 #include <max_flow.h>
 
Index: src/work/marci/bipartite_matching_try_3.cc
===================================================================
--- src/work/marci/bipartite_matching_try_3.cc	(revision 512)
+++ src/work/marci/bipartite_matching_try_3.cc	(revision 555)
@@ -8,9 +8,9 @@
 //#include <smart_graph.h>
 //#include <dimacs.h>
-#include <time_measure.h>
+#include <hugo/time_measure.h>
 #include <for_each_macros.h>
 #include <bfs_iterator.h>
 #include <bipartite_graph_wrapper.h>
-#include <maps.h>
+#include <hugo/maps.h>
 #include <max_flow.h>
 
Index: src/work/marci/lg_vs_sg.cc
===================================================================
--- src/work/marci/lg_vs_sg.cc	(revision 480)
+++ src/work/marci/lg_vs_sg.cc	(revision 555)
@@ -5,8 +5,8 @@
 
 #include <list_graph.h>
-#include <smart_graph.h>
-#include <dimacs.h>
+#include <hugo/smart_graph.h>
+#include <hugo/dimacs.h>
 #include <max_flow.h>
-#include <time_measure.h>
+#include <hugo/time_measure.h>
 #include <for_each_macros.h>
 
Index: src/work/marci/makefile
===================================================================
--- src/work/marci/makefile	(revision 549)
+++ src/work/marci/makefile	(revision 555)
@@ -2,5 +2,5 @@
 CXX3=$(CXX)
 BOOSTROOT ?= /home/marci/boost
-INCLUDEDIRS ?= -I../.. -I../../hugo -I.. -I../{marci,jacint,alpar,klao,akos,athos} -I$(BOOSTROOT)
+INCLUDEDIRS ?= -I../.. -I.. -I../{marci,jacint,alpar,klao,akos,athos} -I$(BOOSTROOT)
 
 LEDABINARIES = leda_graph_demo leda_bfs_dfs max_bipartite_matching_demo
Index: src/work/marci/max_flow_demo.cc
===================================================================
--- src/work/marci/max_flow_demo.cc	(revision 480)
+++ src/work/marci/max_flow_demo.cc	(revision 555)
@@ -4,7 +4,7 @@
 
 #include <list_graph.h>
-#include <smart_graph.h>
-#include <dimacs.h>
-#include <time_measure.h>
+#include <hugo/smart_graph.h>
+#include <hugo/dimacs.h>
+#include <hugo/time_measure.h>
 //#include <graph_wrapper.h>
 #include <max_flow.h>